//
//  NSStringExtensions.h
//  Malkinware
//
//  Created by Jim McGowan on 13/04/2008.
//  Copyright 2008 Jim McGowan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MWLog.h"


@interface NSString (MWNSStringExtensions)

+ (NSString *)stringWithUUID;
+ (NSString *)stringWithContentsOfPlainTextFileOfUnknownEncoding:(NSURL *)fileURL usedEncoding:(NSStringEncoding *)out_fileEncoding; // May return nil if encoding cannot be determined

- (NSString *)firstCharacter;
- (NSString *)lastCharacter;

- (NSString *)stringByRemovingTrailingWhiteSpace;
- (NSString *)stringByRemovingLeadingWhiteSpace;
- (NSString *)stringByRemovingLeadingAndTrailingWhiteSpace;
- (NSString *)stringByRemovingTrailingPeriod;
- (NSString *)stringByRemovingTrailingWhiteSpaceAndPunctuation;	// does not remove a final '.'
- (NSString *)stringByRemovingLeadingWhiteSpaceAndPunctuation;
- (NSString *)stringByRemovingLeadingAndTrailingWhiteSpaceAndPunctuation;
- (NSString *)stringByRemovingCharactersInSet:(NSCharacterSet *)set;

- (NSString *)stringByConvertingLiteralOrdinalsToNumeric;	// does 1 - 10 only

- (NSString *)stringByPercentEncodingCharactersInSet:(NSCharacterSet *)charSet;


#pragma mark 10.7 Compatibility Code
- (NSString *)capitalizedString_WithCurrentLocaleIfAvailable; // uses -capitalizedStringWithLocale:[NSLocale currentLocale] on 10.8+ or -capitalizedString on earlier systems
- (NSString *)lowercaseString_WithCurrentLocaleIfAvailable;
- (NSString *)uppercaseString_WithCurrentLocaleIfAvailable;

@end
